#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long int n, m, i=0, j=0, c=0;

    cin>>n>>m;

    long long int b[m+1], a[n];

    for(i=1; i<=m; i++)
    {
        cin>>b[i];
    }

    for(i=0; i<n-m; i++)
    {
        a[i]=i;
    }

        cin>>c;

    for(i=0; i<=n-m; i++)
    {
        for(j=1; j<=m; j++)
        {
            a[i + b[j]] = a[i + j];
        }
    }

    long long int brojac = 0;

    for(long long k=n; k>0; k--)
    {
        brojac = ((a[k] + brojac) * c ) % 998244353;
    }
    cout<<brojac<<endl;
    return 0;
}